SoGeometryShader(3)

NAME
SoGeometryShader - The SoGeometryShader class is used for loading geometry shader programs.

SYNOPSIS

#include <Inventor/nodes/SoGeometryShader.h>

Inherits SoShaderObject.

  Public Types
enum InputType { POINTS_IN, LINES_IN, TRIANGLES_IN }
enum OutputType { POINTS_OUT, LINE_STRIP_OUT, TRIANGLE_STRIP_OUT }

  Public Member Functions
virtual SoType getTypeId (void) const
SoGeometryShader (void)
virtual ~SoGeometryShader ()
virtual void GLRender (SoGLRenderAction *action)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SbBool isSupported (SourceType sourceType)

  Public Attributes
SoSFEnum inputType
SoSFEnum outputType
SoSFInt32 maxEmit

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoGeometryShader class is used for loading geometry shader programs. See Shaders in Coin for more information on how to set up a scene graph with shaders.

FILE FORMAT/DEFAULTS:

GeometryShader {
  isActive TRUE
  sourceType FILENAME
  sourceProgram ""
  parameter []
  inputType TRIANGLES_IN
  outputType TRIANGLE_STRIP_OUT
  maxEmit 8
}

See also
    SoShaderObject

    SoShaderProgram

Since
    Coin 2.5

Member Enumeration Documentation

  enum SoGeometryShader::InputType
Enumerates the input types.

Enumerator

POINTS_IN
    Shader uses points as input.

LINES_IN
    Shader uses lines as input.

TRIANGLES_IN
    Shader uses triangles as input. OpenGL will automatically convert quads and polygons into triangles.

  enum SoGeometryShader::OutputType
Enumerates the output types.

Enumerator

POINTS_OUT
    Shader generates points.

LINE_STRIP_OUT
    Shader generates line strips.

TRIANGLE_STRIP_OUT
    Shader generates triangle strips.

Constructor & Destructor Documentation

  SoGeometryShader::SoGeometryShader (void)
Constructor.

  SoGeometryShader::~SoGeometryShader () [virtual]
Destructor.

Member Function Documentation

  SoType SoGeometryShader::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoGeometryShader::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoShaderObject.

  const SoFieldData ** SoGeometryShader::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoGeometryShader::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoShaderObject.

  void SoGeometryShader::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoShaderObject.

  SbBool SoGeometryShader::isSupported (SourceType sourceType) [static]
Returns a boolean indicating whether the requested source type is supported by the OpenGL driver or not.

Beware: To get a correct answer, a valid OpenGL context must be available.

Member Data Documentation

  SoSFEnum SoGeometryShader::inputType
The type of geometry used as input to the shader. Default value is TRIANGLES_IN.

  SoSFEnum SoGeometryShader::outputType
The type of geometry generated from the shader. Default value is TRIANGLE_FAN_OUT.

  SoSFInt32 SoGeometryShader::maxEmit
The maximum number of vertices emitted from the shader. Default value is 8. This corresponds to the GL_GEOMETRY_VERTICES_OUT_EXT enum.

Author

Generated automatically by Doxygen for Coin from the source code.